﻿// TextlineViewEstimate.jsx

// Read PDF-file in folder Info

#targetengine "InterlineCalculator"

/*
// Russian
var mes00 = "Пропорции текстовой строки";
var mes01 = "Расстояние между выносными элементами, пт\u00A0\u00A0";
var mes02 = "Расстояние между соседними строками, пт\u00A0\u00A0";
var mes03 = "Нет открытых документов.";
//var mes04 = "x Height | space width (pt)";  // Высота строчной буквы | ширина пробела пт";
var mes04a = "Высота строчной буквы, пт";
var mes04b = "Ширина пробела пт";
var mes05 = "пт"
var mes06 = "Изменить интерлиньяж";
var mes07 =  "Для выделенного текста интерлиньяж должен быть не меньше ";
var mes08 = "Сделать интерлиньяж текста равным этому значению";
var mes09 = "Не найден PDF-файл с описанием этой программы. Он называется '";
var mes10 = "' и должен быть в папке 'Info' этого скрипта.";
var mes11 = "В этой задаче нет смысла работать с вариантом, когда кегль больше интерлиньяжа.";  
var mes12 = "Должен быть выделен один абзац с числом строк не меньше двух, с конкретным интерлиньяжем (не Авто), без привязки к базовой сетке и без сдвига базовой линии.";
var mes13 = "Выделенный абзац должен быть одной гарнитуры, все знаки одинакового начертания, размера, интерлиньяжа, на нулевой базовой линии.";
var mes14 = "TextlineViewEstimate.Rus.pdf";
*/

// English
var mes00 = "Proportions of a text string"; //  "Пропорции текстовой строки";
var mes01 =  "Distance between descenders and ascenders (pt)\u00A0\u00A0"; // "Расстояние между выносными элементами, пт\u00A0\u00A0";
var mes02 = "Distance between adjacent lines (pt)\u00A0\u00A0"; // "Расстояние между соседними строками, пт\u00A0\u00A0";
var mes03 = "No open documents"; // "Нет открытых документов.";
//var mes04 = "x Height | space width (pt)";  // Высота строчной буквы | ширина пробела пт";
var mes04a = "x-Height (pt)";  // Высота строчной буквы, пт";
var mes04b = "Space width (pt)";  // ширина пробела пт";
var mes05 = "pt"; // "пт"
var mes06 =  "Change leading";  // "Изменить интерлиньяж";
var mes07 =  "For the selected text, the leading must be at least " ; // "Для выделенного текста интерлиньяж должен быть не меньше ";
var mes08 = "Make the text leading equal to this value"; // "Сделать интерлиньяж текста равным этому значению";
var mes09 = "The PDF file with the description of this program was not found. It is named '";
var mes10 = "' and it should be in the 'Info' folder of this script";
var mes11 = "In this task it makes no sense to work with the option when the pointsize is larger than the leading"; // "В этой задаче нет смысла работать с вариантом, когда кегль больше интерлиньяжа.";  
var mes12 = "One paragraph should be selected with at least two lines, with a specific leading (not Auto), without binding to the base grid and without shifting the baseline"; // "Должен быть выделен один абзац с числом строк не меньше двух, с конкретным интерлиньяжем (не Авто), без привязки к базовой сетке и без сдвига базовой линии.";
var mes13 = "The selected paragraph must be of the same typeface, all characters of the same font, size, interlining, on the zero baseline"; // "Выделенный абзац должен быть одной гарнитуры, все знаки одинакового начертания, размера, интерлиньяжа, на нулевой базовой линии.";
var mes14 = "#2Eng.pdf";


var programTitul = mes00; // "Пропорции текстовой строки"
myAuto = 1635019116; // нумератор для учета случая, когда значение интерлиньяжа .leading определено как Auto
debug = false;
var mySel;
var isError;
var chars = [];
var charsNum;
var ch0 = chars[0];
var lead; // интерлиньяж
var pS; // кегль
var font;  // шрифт
var bL = 0;
var allIsOk = true;
var yT; // Y базовой линии первой строки
var yB; //  Y базовой линии второй строки
var xHeight; // высота строчной буквы
var baseline_xHeight_space; // расстояние между базовой линией строки и линией строчных букв следующей строки
var xRight; // x-координата правого края самого правого знака в выделенном тексте
var xLeft; // x-координата левого края самого левого знака в выделенном тексте
var picaLength; // ширина выделенной области в пиках
var asc;  // верхний выносной элемент
var desc; // нижний выносной элемент
var lead0; // расстояние между выносными элементами соседних строк
var infoAboutButton = "";
var spaceBetweenAScDesc = mes01; // "Расстояние между выносными элементами, пт\u00A0\u00A0";
var spaceBetweenLines = mes02; // "Расстояние между соседними строками, пт\u00A0\u00A0";

var wLocation = [-1,-1];

app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll; // см. http://adobeindesign.ru/2008/10/24/restore-ui/ 
if (app.documents.length == 0) {
    alert (mes03, programTitul); // "Нет открытых документов."
    exit();
    }
var myCurrentVertUnits = app.activeDocument.viewPreferences.verticalMeasurementUnits;
app.activeDocument.viewPreferences.verticalMeasurementUnits = MeasurementUnits.POINTS;
var zp = [];
zp = app.activeDocument.zeroPoint;
app.activeDocument.zeroPoint = [0,0]; 

var myScriptFile = myGetScriptPath();
var myDefSetName  = "IntCalc.ini";
var myScriptFolder = decodeURI(myScriptFile.path);
var myFilePath = decodeURI(myScriptFolder + "/sets/" + myDefSetName); 
var dataFile = new File (myFilePath);
if (dataFile.exists) { //File.exists
    dataFile.open("r");
    wLocation[0] = dataFile.readln();
    wLocation[1] = dataFile.readln();   
    dataFile.close();
    } //File.exists    
////
if (getInfo() == null) {
    app.activeDocument.viewPreferences.verticalMeasurementUnits = myCurrentVertUnits;
    app.activeDocument.zeroPoint = zp;
    exit();
    }
var w = new Window( 'palette', programTitul, undefined, {closeButton: true});
if (wLocation[0] != -1) w.location = wLocation;
w.alignChildren = ["fill", "fill"];
var topGroup = w.add("group");
topGroup.orientation = "column";
var leadSize = topGroup.add("group");
leadSize.alignChildren = ["fill", "fill"];
leadSize.orientation = "row";
var xHeightGroup = leadSize.add("group");
xHeightGroup.alignChildren = ["left", "fill"];
xHeightGroup.orientation = "column";
var xHtValue = xHeightGroup.add("group");
xHtValue.orientation = "row";
xHtValue.alignChildren = ["left", "fill"];
xHtValue.add("statictext", undefined, mes04a); //  "Высота строчной буквы"
var xHtData = xHtValue.add("statictext", undefined, xHeight.toFixed(3));
xHtValue.add("statictext", undefined, "|");
xHtValue.add("statictext", undefined, mes04b); // ширина пробела, пт"
var xHtSpace = xHtValue.add("statictext", undefined, (pS/4).toFixed(3));
var unit = mes05; // "пт"
var spaceAscDesc = xHeightGroup.add("statictext", undefined, spaceBetweenAScDesc + lead0.toFixed(3));
var spaceLines  = xHeightGroup.add("statictext", undefined, spaceBetweenLines + baseline_xHeight_space.toFixed(3));
var separator_z = leadSize.add ("panel");
separator_z.minimumSize.width = separator_z.maximumSize.width = 1;
var leadControl = leadSize.add("group");
leadControl.alignChildren = ["fill", "fill"];
leadControl.orientation = "column";
var changeValue = leadControl.add("group");
changeValue.alignChildren = ["left", "center"];
changeValue.orientation = "row";
changeValue.add("statictext",undefined, mes06); // "Изменить интерлиньяж"
var buttonPlusMinusSize = [0,0,28,28];
var leadPlus = changeValue.add("button", buttonPlusMinusSize, "+");
changeValue.add("statictext", [0,0,0,28], "");
var leadMinus = changeValue.add("button", buttonPlusMinusSize, "–");
var separator_x = changeValue.add ("panel");
separator_x.minimumSize.width = separator_x.maximumSize.width = 1;
var rbGroup = leadControl.add("group");
rbGroup.orientation = "row";
rbGroup.alignChildren = ["left", "fill"];
var rbLine = rbGroup.add("group");
rbLine.orientation = "row";
rbLine.alignChildren = ["left", "center"];
var step1 = rbLine.add("radiobutton", undefined, "1 " + unit);
var step25 = rbLine.add("radiobutton", undefined, "0.25 " + unit);
var step50 = rbLine.add("radiobutton", undefined, "0.5 " + unit);
step50.value = true;
var separator_y = w.add ("panel");
separator_y.minimumSize.height = separator_y.maximumSize.height = 1;
var bottomGroup = w.add("group");
bottomGroup.orientation = "row";
bottomGroup.alignChildren = ["left", "fill"];
var infoGroup = bottomGroup.add("group");
infoGroup.alignChildren = ["center", "fill"];
var info = infoGroup.add("button", [0,0,28,28], "?");

var separator_g = bottomGroup.add ("panel");
separator_g.minimumSize.width = separator_g.maximumSize.width = 1;

var minUntGroup = bottomGroup.add("group");
minUntGroup.orientation = "row";
minUntGroup.alignChildren = ["left", "center"];

var minRightLeadText = mes07; // "Для выделенного текста интерлиньяж должен быть не меньше ";
var itest = "        ";
var minRightLeading = minUntGroup.add("statictext", undefined, minRightLeadText + itest + " " + unit);
var setLead = minUntGroup.add("checkbox");
setLead.value = false;
setLead.helpTip = mes08; // "Сделать интерлиньяж текста равным этому значению";
///
step1.onClick = function () { getInfo(); app.activate(); }
step25.onClick = function () { getInfo(); app.activate(); }
step50.onClick = function () { getInfo(); app.activate(); }
///
leadPlus.onClick = function() { // leadPlus.onClick
var giRez = getInfo(); 
if (giRez == null) return;
if (step1.value) mySel.leading += 1;
else if (step25.value) mySel.leading += 0.25;
else mySel.leading += 0.5;
getInfo();
try {
    // при первом запуске может не быть информации о полях рабочего окна
    xHtSpace.text = (pS/4).toFixed(3);
    xHtData.text = xHeight.toFixed(3);
    spaceAscDesc.text = spaceBetweenAScDesc + lead0.toFixed(3);
    spaceLines.text = spaceBetweenLines + baseline_xHeight_space.toFixed(3);
    testRestrictions();
    }
catch (e) { }
app.activate();
} // leadPlus.onClick
///////
function testRestrictions() { // testRestrictions()
if (Number(lead0) <= Number(pS/4)) spaceAscDesc.text = "• " + spaceAscDesc.text; // условие I
if (Number(baseline_xHeight_space) <= Number(xHeight)) spaceLines.text = "• " + spaceLines.text; // условие II
} // testRestrictions()
/////
info.onClick = function() { // info.onClick
var pdfName = mes14;
app.pdfExportPreferences.properties.viewPDF = true;   
var myScriptFile = myGetScriptPath();
var myScriptFolder = decodeURI(myScriptFile.path);  
var infoFile = File(decodeURI(myScriptFolder + "/Info/" + pdfName)); 
if (!infoFile.exists) { 
    alert(mes09 + pdfName + mes10,programTitul); 
    return; 
    }
else {
        infoFile.execute();
    }
} // info.onClick
///
leadMinus.onClick = function() { // leadMinus.onClick
var nosolved = mes11; // "В этой задаче нет смысла работать с вариантом, когда кегль больше интерлиньяжа.";  
var incr;    
var giRez = getInfo(); 
if (giRez == null) return;
if (giRez == 1) {
    alert (nosolved + " [1]", programTitul); 
    return;
    }
if (step1.value) incr = 1;
else if (step25.value) incr = 0.25;
else incr = 0.5;
var minusIncr = mySel.leading - incr;
if (minusIncr < pS) {
    alert (nosolved + " [2]", programTitul); 
    return;
    }
mySel.leading -= incr;
getInfo();
try {
    // при первом запуске может не быть информации о полях рабочего окна
    xHtSpace.text = (pS/4).toFixed(3);
    xHtData.text = xHeight.toFixed(3);
    spaceAscDesc.text = spaceBetweenAScDesc + lead0.toFixed(3);
    spaceLines.text = spaceBetweenLines + baseline_xHeight_space.toFixed(3);
    testRestrictions();
    }
catch (e) { }
app.activate();
} // leadMinus.onClick
///
w.onClose = function() {
app.activate();     
if (app.documents.length == 0) exit();
app.activeDocument.viewPreferences.verticalMeasurementUnits = myCurrentVertUnits;
app.activeDocument.zeroPoint = zp;
dataFile.open("w");
dataFile.writeln(w.location[0]);
dataFile.writeln(w.location[1]);
dataFile.close();
} // w.onClose
////
getInfo();
w.show();
////////////
setLead.onClick = function () { // setLead.onClick
mySel = app.selection[0];
try {
    mySel.leading = itest;
    }
catch (e) { };
setLead.value = false;
getInfo();
} // setLead.onClick
//////////
function getInfo() { // getInfo
mySel = app.selection[0];
var debugLine;
isError = false;
var payAttentionToSelection = false;
var payAttentionToParagraph = false;
var payAttentionToLeadingAlign = false;
if (mySel == null || (mySel.constructor.name != "InsertionPoint"  && mySel.constructor.name != "Paragraph" && mySel.constructor.name != "Text" && mySel.constructor.name != "TextColumn" && mySel.constructor.name != "TextStyleRange")) { // == null
    payAttentionToSelection = true;
    isError = true;  
    } // == null
if (!isError) { // !isError
    if (mySel.constructor.name == "InsertionPoint") {
        mySel.paragraphs[0].select();
        mySel = app.selection[0];
        }
    try { // try
        if ((mySel.paragraphs.length != 1) || (mySel.paragraphs[0].lines.length < 2)) {
            payAttentionToParagraph = true;
            isError = true;    
            }
        if ((mySel.leading == myAuto) || mySel.alignToBaseline) {
            payAttentionToLeadingAlign = true;
            isError = true;       
            }
        } // try
    catch (e) { isError = true; }
    } // !isError
if (isError) {
    debugLine = "\r\rdebugLine:\rpayAttentionToSelection = " + payAttentionToSelection + ",\rpayAttentionToParagraph = " + payAttentionToParagraph + ",\rpayAttentionToLeadingAlign = " + payAttentionToLeadingAlign;
    alert (mes12 + debugLine, programTitul); // "Должен быть выделен один абзац с числом строк не меньше двух, с конкретным интерлиньяжем (не Авто), без привязки к базовой сетке и без сдвига базовой линии."
    return null;    
    }
mySel.paragraphs[0].select();
mySel = app.selection[0];
chars = [];
while (chars.length > 0) chars.shift();
chars = mySel.characters.everyItem().getElements();
charsNum = chars.length;
ch0 = chars[0];
lead = ch0.leading; // интерлиньяж
pS = ch0.pointSize; // кегль
font = ch0.appliedFont;  // шрифт
//bL = ch0.baselineShift;
bL = 0;
allIsOk = true;
xRight = -99999;
xLeft = 999999;
var myCurrentHorUnits = app.activeDocument.viewPreferences.horizontalMeasurementUnits;
app.activeDocument.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.PICAS;
for (i = 1; i < charsNum; i++) { // i++
    if (chars[i].endHorizontalOffset > xRight) xRight = chars[i].endHorizontalOffset; 
    if (chars[i].horizontalOffset < xLeft) xLeft = chars[i].horizontalOffset;    
    if ((chars[i].pointSize  == pS) && (chars[i].appliedFont == font)  && (chars[i].baselineShift == bL)  && (chars[i].leading == lead)) continue;
    allIsOk = false;
    debugLine = "\r\rdebugLine:\r i = " + i + " | charsNum = " + charsNum + ",\r(chars[i].appliedFont == font) " + (chars[i].appliedFont == font) + ",\r(chars[i].baselineShift == bL) " + (chars[i].baselineShift == bL) + ",\r(chars[i].leading == lead) " + (chars[i].leading == lead) + ".\r\rchars[i].appliedFont = " + chars[i].appliedFont.name + "\rfont = " + font.name;
    break;
    } // i++
if (!allIsOk) {
    alert (mes13 + debugLine, programTitul); // "Выделенный абзац должен быть одной гарнитуры, все знаки одинакового начертания, размера, интерлиньяжа, на нулевой базовой линии."
    app.activeDocument.viewPreferences.horizontalMeasurementUnits = myCurrentHorUnits;
    return null;      
    }
picaLength = (xRight - xLeft).toFixed(3);
app.activeDocument.viewPreferences.horizontalMeasurementUnits = myCurrentHorUnits;
itest = picaLength/pS + pS;
var nInt = parseInt(itest);
var rest = itest - nInt;
if (rest >= 0 && rest < 0.25) { itest = nInt; }
else if (rest >= 0.25 && rest < 0.75) { itest = nInt + 0.5; }
else if (rest >= 0.75) { itest = nInt+1; }
try {
    minRightLeading.text = minRightLeadText + itest + " " + unit;
    }
catch (e) { };
asc = ch0.ascent;  // верхний выносной элемент
desc = ch0.descent; // нижний выносной элемент
if (debug) $.writeln("----------------------------------");
if (debug) $.writeln("pointsize = " + pS + " | asc = " + asc + " | desc = " + desc);
//asc_desc_sum = Number(asc) + Number(desc); // сумма не всегда равна кеглю, например, у верданы, баскервиля это не так. А у мириада, миньона есть равенство
yT = mySel.lines[0].baseline;
yB = mySel.lines[1].baseline;
lead0 = (yB - asc) - (Number(yT) + Number(desc)); // расстояние между выносными элементами соседних строк
if (debug) $.writeln("yT = " + yT + " | yB = " + yB + " | lead0 = " + lead0);
getSize(pS, font); // узнали высоту строчной буквы
baseline_xHeight_space = yB - xHeight - yT; // расстояние между базовой линией строки и линией строчных букв следующей строки. Визуально это свободное расстояние между низом строки букв верхней строки и линией строчных букв нижней
if (debug) $.writeln("xHeight = " + xHeight + " | baseline_xHeight_space = " + baseline_xHeight_space);
try {
    // при первом запуске может не быть информации о полях рабочего окна
    spaceAscDesc.text = spaceBetweenAScDesc + lead0.toFixed(3);
    spaceLines.text = spaceBetweenLines + baseline_xHeight_space.toFixed(3);
    xHtSpace.text = (pS/4).toFixed(3);
    xHtData.text = xHeight.toFixed(3);   
    testRestrictions();
    }
catch (e) { };
if (lead < pS) {
    //alert ("В этой задаче нет смысла работать с вариантом, когда кегль больше интерлиньяжа.", programTitul); 
    return 1;    
    }
return 0;
} // getInfo
////////////
function getSize(pointsize, font) { // getSize  
var myT = app.activeDocument.pages[0].textFrames.add({geometricBounds:["-40pt","-40pt","-5pt","-5pt"], strokeWeight:0});
myT.textWrapPreferences.textWrapMode = TextWrapModes.NONE;
myT.strokeWeight = 0;
myT.textFramePreferences.ignoreWrap = true;
myT.textFramePreferences.verticalJustification = VerticalJustification.TOP_ALIGN; 
myT.texts[0].alignToBaseline = false;
myT.textFramePreferences.firstBaselineOffset = FirstBaseline.X_HEIGHT;
myT.texts[0].pointSize = pointsize;
myT.texts[0].contents = "";
myT.texts[0].insertionPoints[0].contents = "z";
myT.texts[0].appliedFont = font;
xHeight = Math.abs(myT.characters[0].baseline - myT.geometricBounds[0]);
if (debug) $.writeln("myT.geometricBounds[0] = " + myT.geometricBounds[0] + " | myT.characters[0].baseline = " + myT.characters[0].baseline + " | xHeight = " + xHeight);
myT.remove();
return xHeight;
} // getSize
////////////////
function myGetScriptPath() { // myGetScriptPath
try {
    return app.activeScript;
}
catch (myError) {
    return File(myError.fileName);
}
} // myGetScriptPath()
////////////////

