﻿// SaveMarginsInfo.jsx

#targetengine "SaveMarginsInfo"
// 19.11.2021

// dotextok.ru

/*
/// rus {
var ms01 = "Сохранение оформления";
var ms02 = "ru";
var ms03 = "Создать новый файл";
var ms04 = "Сохранить оформление";
var ms05 = "> \"Создать новый файл\" — ввести размеры во все поля, нажать \"OK\", и будет создана заготовка книги с такими размерами.\n\Единицы измерения берутся или из установок открытого файла или из установок индизайна (Редактирование > Установки > Единицы измерения).\n • \"Поля по размеру выбранного фрейма\" — если открыт документ, в нём на нечётной стороне разворота выделен прямоугольник, то на основе его координат и габаритов будут заполнены все поля.\n • \"Ввод значений пользователем\" — пользователь заполняет все поля для создания документа.\n\nВсе расчёты ведутся, исходя из величины корешка. После ввода этого значения можно ввести величины остальных полей, а можно указать пропорцию, и поля будут вычислены. Указание полей покажет соотношение их размеров; указание пропорции изменит поля. Очерёдность чисел в пропорции — корешковое поле : верхнее поле : внешнее поле : нижнее поле.\nДля понимания результата выводятся размеры полосы при таких значениях полей.\n\nПользователь может ввести пропорцию, в которой первое число любое, например, 2:2.5:3.15:4, но если пропорцию составляет программа на основе полей, то эта строка будет начинаться с единицы.\nВ дробях разделитель не запятая, а точка.\n\nЧтобы программа стала работать с введенными в поле данными, надо щёлкнуть мышкой за пределами поля.\n\nЗамечена такая особенность, что иногда поле пропорций не берётся в работу. Будто программа считает, что ничего не изменилось. В этом случае поможет добавление одной цифры в пропорцию, щелчок мышкой за пределами поля, а потом возврат нужного значения и повторный запуск пересчёта.\n\n\n> \"Сохранить оформление\" — размер страницы и поля сохраняются для использования в программе \"Пропорции полей страницы\". К информации можно добавить строку комментария.\nЭта информация помещается в файл 'BookMarginsInfo.txt'. Содержимое данного файла помещается в выпадающий список вариантов оформления книги.\nСреди задаваемых размеров поправки на клей нет, но тут она сохранена как нулевое значение, чтобы сбросить текущее значение поправки, если эта запись будет выбрана.\nЕсли какой-то вариант совсем не нужен, его следует удалить из этого файла. Если требуется только отключить на время, то для этого надо поставить в начале строки дефис.\n\n";
var ms06 = "Нет открытого файла.";
var ms07 = "Эта служебная программа для работы с книгами, поэтому информация сохраняется только о документе, имеющем развороты.";
var ms08 = "Файл '";
var ms09 = "' не найден.";
var ms10 = "Текст новой записи в BookMarginsInfo.txt";
var ms11 = "Информация о размере и полях:";
var ms12 = "Комментарий";
var ms13 = "Новый документ";
var ms14F = "Поля по размеру выбранного фрейма";
var ms14help = "";
var ms14U = "Ввод значений пользователем";
var ms15 = "Ширина страницы";
var ms16 = "Высота страницы";
var ms17 = "Корешковое поле";
var ms18 = "Поля";
var ms19 = "Пропорция";
var ms20 = "Верхнее поле";
var ms21 = "Внешнее поле";
var ms22 = "Нижнее поле";
var ms23 = "Ширина полосы";
var ms24 = "Высота полосы";
var bU = ", "; // bU === before Unit
var aU = ""; // aU === after Unit
/// }
*/
/// eng {

var ms01 = "Saving the layout design";
var ms02 = "us";
var ms03 = "Create new file";
var ms04 = "Save the design";
var ms05 = "> \"Create new file\" — input values in all fields, type \"OK\", and prototype of the layout with these dimensions will be created.\nUnits of measurement are taken either from the settings of an open file or from the settings of an InDesign (Edit > Preferences > Units & Increments).\n • \"Margins according to the size of the selected frame\" — if a document is open and a rectangle is highlighted on the odd side of the spread, then all fields will be filled based on its coordinates and dimensions.\nThis option is useful if you have a PDF book that has both a frame for the main text and a footer, and you want to get the proportions of this book for use in your work. It is necessary to place a PDF of an odd page in a rectangle in an InDesign, cover the text frame and footer with a rectangle, select it, and then run this script. Option \"Margins according to the size of the selected frame\" will be available. Type OK, and then select radiobutton \"Save the design\".\n\n • \"User input of values\" — the user fills in all the fields to create a document. In case of an input error, a question mark will appear next to the field.\n\nAll calculations are carried out based on the size of the inside margin. After entering this value, you can enter the values of the remaining fields or specify the proportion, and the fields will be calculated. When specifying fields, the ratio of their sizes will be shown; when specifying the proportions of the fields will change. The sequence of numbers in proportion is the inside: top: outside: bottom.\nTo understand the result, the calculated sizes margins and type area are displayed.\n\nThe user can enter a proportion in which the first number is any, for example, 2 : 2.5 : 3.15 : 4, but if the proportion is produced by program, then this line will start with 1.0.\nIn fractions, the separator is not a comma, but a dot.\n\nIn order for the program to work with the data entered in the field, you need to click outside the field.\n\nSuch a feature is noticed that sometimes the field of proportions is not taken into work. As if the program thinks that nothing has changed. In this case, adding one digit to the proportion, clicking the mouse outside the field, and then returning the desired value and restarting the recalculation will help.\n\n> \"Save the design\" — the page size, inside margin and ratio data are saved for use in the program \"Proportions of page margins\". You can add a comment line to the information.\n\nThis information is placed in a file 'BookMarginsInfo.txt'. The contents of this file are placed in the dropdown list of book design variants in the program \"Proportions of page margins\".\nThere is no correction for glue among the specified sizes, but here it is saved as a zero value in order to reset the current correction value if this entry is selected.\n\nIf an option is not needed at all, it should be removed from this file. If you only need to disable it for a while, then for this you need to put a hyphen at the beginning of the line.\n";
var ms06 = "No opened file";
var ms07 = "This is a service program for working with books, so information is stored only about the document with facing pages";
var ms08 = "File '";
var ms09 = "' not found";
var ms10 = "The text of the new entry for BookMarginsInfo.txt";
var ms11 = "Information about measure and margins:";
var ms12 = "Comment";
var ms13 = "New document";
var ms14F = "Margins according to the size of …";
var ms14help = "Margins according to the size of the selected frame";
var ms14U = "User input of values";
var ms15 = "Page width";
var ms16 = "Page height";
var ms17 = "Inside margin";
var ms18 = "Margins";
var ms19 = "Proportion";
var ms20 = "Top margin";
var ms21 = "Outside margin";
var ms22 = "Bottom margin";
var ms23 = "Width text area";
var ms24 = "Height text area";
var bU = " ("; // bU === before Unit
var aU = ")"; // aU === after Unit

/// }

var programTitul = ms01; // "Сохранение оформления"
var horUnit;
var verUnit;
var isFile = false;
var newFileMade = false;
var spine_cu; // величина корешка в текстовом виде, например, 3p6
var theRatio;

// все параметры-Data --- величины в нормальном десятичном виде (даже если при вводе они были, например, в таком виде 40p1.89). Поэтому их можно складывать, вычитать, и пр.
var spineData;
var topData;
var outData;
var bottomData;
var widthData;
var heightData;

if (app.documents.length == 0) {
    horUnit = app.viewPreferences.horizontalMeasurementUnits;
    verUnit = app.viewPreferences.verticalMeasurementUnits;    
    }
else {
    var doc = app.activeDocument;
    isFile = true;
    horUnit = doc.viewPreferences.horizontalMeasurementUnits;
    verUnit = doc.viewPreferences.verticalMeasurementUnits;
    var ro = doc.viewPreferences.rulerOrigin;
    doc.viewPreferences.rulerOrigin = 1380143983; // SPREAD_ORIGIN
    var zp = [];
    zp = doc.zeroPoint;
    doc.zeroPoint = [0,0];    
    }
var country = ms02; // "ru"  |  "us"
var pica = true; // если pica = true, то русское название этой единицы измерения "пика", если pica = false, то "пайка"
var w = new Window( 'palette', programTitul, undefined, {closeButton: true});
var rb = w.add("group");
rb.orientation = "row";
rb.alignChildren = ["center", "center"];
var addDoc = rb.add("radiobutton", undefined, ms03); // "Создать новый файл"
var info = rb.add("button", [0,0,28,28], "?");
var save = rb.add("radiobutton", undefined, ms04); // "Сохранить оформление"
save.enabled = false;
///
w.onClose = function() {
try {    
    if (isFile) {    
        doc.zeroPoint = zp;
        doc.viewPreferences.rulerOrigin = ro;
        }
    }
catch (e) { }
}    
///
addDoc.onClick = function () { // addDoc.onClick
makeNewDoc(); 
//app.activate();   
} // addDoc.onClick
//////
info.onClick = function() { // info.onClick
var messLine = ms05; // "> \"Создать новый файл\" — ввести размеры во все поля, нажать \"OK\", и будет создана заготовка книги с такими размерами.\n\Единицы измерения берутся или из установок открытого файла или из установок индизайна (Редактирование > Установки > Единицы измерения).\n • \"Поля по размеру выбранного фрейма\" — если открыт документ, в нём на нечётной стороне разворота выделен прямоугольник, то на основе его координат и габаритов будут заполнены все поля.\n • \"Ввод значений пользователем\" — пользователь заполняет все поля для создания документа.\n\nВсе расчёты ведутся, исходя из величины корешка. После ввода этого значения можно ввести величины остальных полей, а можно указать пропорцию, и поля будут вычислены. Указание полей покажет соотношение их размеров; указание пропорции изменит поля. Очерёдность чисел в пропорции — корешковое поле : верхнее поле : внешнее поле : нижнее поле.\nДля понимания результата выводятся размеры полосы при таких значениях полей.\n\nПользователь может ввести пропорцию, в которой первое число любое, например, 2:2.5:3.15:4, но если пропорцию составляет программа на основе полей, то эта строка будет начинаться с единицы.\nВ дробях разделитель не запятая, а точка.\n\nЧтобы программа стала работать с введенными в поле данными, надо щёлкнуть мышкой за пределами поля.\n\nЗамечена такая особенность, что иногда поле пропорций не берётся в работу. Будто программа считает, что ничего не изменилось. В этом случае поможет добавление одной цифры в пропорцию, щелчок мышкой за пределами поля, а потом возврат нужного значения и повторный запуск пересчёта.\n\n\n> \"Сохранить оформление\" — размер страницы и поля сохраняются для использования в программе \"Пропорции полей страницы\". К информации можно добавить строку комментария.\nЭта информация помещается в файл 'BookMarginsInfo.txt'. Содержимое данного файла помещается в выпадающий список вариантов оформления книги.\nЕсли какой-то вариант совсем не нужен, его следует удалить из этого файла. Если требуется только отключить на время, то для этого надо поставить в начале строки дефис.\n\n"
alert(messLine, programTitul);
} // info.onClick
////
save.onClick = function () { // save.onClick 
saveInfo();
save.value = false;
} // save.onClick
////
function saveInfo() { // saveInfo()
if (app.documents.length == 0) {
    alert(ms06, programTitul); // "Нет открытого файла."
    return;
    }
if (app.activeDocument.documentPreferences.facingPages == false) {
    alert(ms07, programTitul); // "Эта служебная программа для работы с книгами, поэтому информация сохраняется только о документе, имеющем развороты."
    return;
    }  
var myScriptFile = myGetScriptPath();
var myDefSetName  = "BookMarginsInfo.txt";
var myScriptFolder = decodeURI(myScriptFile.path);
var myFilePath = decodeURI(myScriptFolder + "/" + myDefSetName); 
var dataFile = new File (myFilePath);
if (!dataFile.exists) { // !/File.exists
    alert(ms08 + myDefSetName + ms09); // "Файл '"    "' не найден." 
    return;
    }  
var d = app.activeDocument;
var w = numberToShow(d.documentPreferences.pageWidth, horUnit) + "_" + getHorizontalUnit("us");
var h = numberToShow(d.documentPreferences.pageHeight, verUnit) + "_" + getVerticalUnit("us");
var f = spine_cu;
var g = 0;

var infoLine = w + "|" + h + "|" + f + "|" + g + "| " + theRatio;

var sw = new Window( 'dialog', ms10, undefined, {closeButton: true}); // "Текст новой записи"
sw.alignChildren = ["fill", "fill"];
sw.add("statictext", undefined, ms11); // "Информация о размере и полях:"
sw.add("statictext", undefined,infoLine);
sw.add("statictext", undefined, ms12); // "Комментарий"
var comment = sw.add("edittext {justify: 'center'}");
comment.characters= 50;
 var buttons = sw.add("group");
buttons.alignChildren = ["fill", "center"];
buttons.orientation = "row";
var ok = buttons.add("button", undefined, "OK");
var cancel = buttons.add("button", undefined, "Cancel");
///
cancel.onClick = function() { // cancel.onClick     
sw.close();
} // cancel.onClick 
////
ok.onClick = function () { // ok.onClick 
if (comment.length != 0) infoLine = infoLine + " * " + comment.text; 
dataFile.open("a");
dataFile.writeln(infoLine);
dataFile.close();
sw.close(); 
return;
} // ok.onClick 
////
sw.show();
} // saveInfo() 
////////
w.show();
////////////////
function getHorizontalUnit(locale) { // getHorizontalUnit
switch (horUnit) { // switch
case 2051106676: return 'ag';
case 2053336435: { if (locale == "ru") return 'см';  else return 'cm'; }
case 2053335395: { if (locale == "ru") return 'цицеро';  else return 'c'; }
case 2053729891: { if (locale == "ru") return 'дюйм';  else return 'in'; }
case 2053729892: { if (locale == "ru") return 'дюйм';  else return 'in'; }
case MeasurementUnits.PIXELS: return 'px';
case 2053991795: { if (locale == "ru") return 'мм';  else return 'mm'; }
case 2054187363: { // p
    if (locale == "ru") { // ru
        if (pica) return 'пики'; else return 'пайки';
        }  // ru
    else return 'p';
    } // p
case 2054188905: { if (locale == "ru") return 'пт';  else return 'pt'; }
} // switch    
} // getHorizontalUnit 
////////
function getVerticalUnit(locale) { // getVerticalUnit
switch (verUnit) { // switch
case 2051106676: return 'ag';
case 2053336435: { if (locale == "ru") return 'см';  else return 'cm'; }
case 2053335395: { if (locale == "ru") return 'цицеро';  else return 'c'; }
case 2053729891: { if (locale == "ru") return 'дюйм';  else return 'in'; }
case 2053729892: { if (locale == "ru") return 'дюйм';  else return 'in'; }
case MeasurementUnits.PIXELS: return 'px';
case 2053991795: { if (locale == "ru") return 'мм';  else return 'mm'; }
case 2054187363: { // p
    if (locale == "ru") { // ru
        if (pica) return 'пики'; else return 'пайки';
        }  // ru
    else return 'p';
    } // p
case 2054188905: { if (locale == "ru") return 'пт';  else return 'pt'; }
} // switch    
} // getVerticalUnit 
//////////
function getDataValue(value, unit) { // getDataValue
// возвращает число в десятичном виде    
var theValue = value; 
if (unit != 2054187363 && unit != 2053335395) {
    if (isNaN(value) == true || value <= 0) return null; else return value;
    }
var vRez = [];
while (vRez.length > 0) vRez.shift();
if (String(value).match("p") != null) { // p
    vRez = value.split("p");
    if (vRez.length > 2) return null;
    if ((isNaN(vRez[0]) == true) || (isNaN(vRez[1]) == true) || vRez[0] < 0) return null;
    theValue = Number(vRez[0]) + Number(vRez[1]/12); // перевели число в десятичную форму
    }  // p
else if (String(value).match("c") != null) { // c
    vRez = value.split("c");
    if (vRez.length > 2) return null;
    if ((isNaN(vRez[0]) == true) || (isNaN(vRez[1]) == true) || vRez[0] < 0) return null;    
    theValue = Number(vRez[0]) + Number(vRez[1]/12);  // перевели число в десятичную форму
    } // c
if (isNaN(theValue) == true) return null;
if (theValue <= 0) return null;
return Number(theValue);
} // getDataValue
////////////
function makeNewDoc() { // makeNewDoc
var aw = new Window( 'palette', ms13, undefined, {closeButton: true}); // "Новый документ"
aw.alignChildren = ["fill", "fill"];
var sizesFromFrame = aw.add("radiobutton", undefined, ms14F); // "Поля по размеру выбранного фрейма"
sizesFromFrame.helpTip = ms14help;
var sizesFromUser = aw.add("radiobutton", undefined, ms14U); // "Ввод значений пользователем"
sizesFromUser.value = true;
if (app.documents.length > 0) { // .length > 0
    var ms = app.selection[0];
    if (ms == null) sizesFromFrame.enabled = false;
    if (ms != null) { // != null
        var noError = true;
        if (app.activeDocument.documentPreferences.facingPages == false) { sizesFromFrame.enabled = false; noError = false; }
        else if (noError && (ms.constructor.name != "Rectangle")) { sizesFromFrame.enabled = false; noError = false; }
        else if (noError && (ms.parentPage.name%2 != 1)) { sizesFromFrame.enabled = false; noError = false; }
        if (noError) { // noError
            var wth = doc.documentPreferences.pageWidth;
            var gb = ms.geometricBounds;
            if ((gb[1] <= 0) || (gb[1] <= wth) || (gb[3] >=wth*2)) sizesFromFrame.enabled = false;
            } // noError
        } // != null
    } // .length > 0
else sizesFromFrame.enabled = false;
separator_с = aw.add ("panel");
separator_с.minimumSize.height = separator_с.maximumSize.height = 1; 
var width = aw.add("group");
width.orientation = "row";
width.alignChildren = ["left", "center"];
var letterSpace = [0,0,14,28];
var widthState = width.add("statictext", letterSpace, "–");
var widthValue = width.add("edittext {justify: 'center'}");
widthValue.text = "?";
widthValue.characters = 6; 
var widthText = ms15  + bU + getHorizontalUnit(country) + aU; // "Ширина страницы,"
var widthInfo = width.add("statictext", undefined, widthText);

var height = aw.add("group");
height.orientation = "row";
height.alignChildren = ["left", "center"];
var heightState = height.add("statictext", letterSpace, "–");
var heightValue = height.add("edittext {justify: 'center'}");
heightValue.text = "?";
heightValue.characters = 6; 
var heightText = ms16+ bU + getVerticalUnit(country) + aU; // "Высота страницы,"
var heightInfo = height.add("statictext", undefined, heightText);

var spine = aw.add("group");
spine.orientation = "row";
spine.alignChildren = ["left", "center"];
var spineState = spine.add("statictext", letterSpace, "–");
var spineValue = spine.add("edittext {justify: 'center'}");
spineValue.text = "?";
spineValue.characters = 6; 
var spineText = ms17 + bU + getHorizontalUnit(country) + aU; // "Корешковое поле,"
var spineInfo = spine.add("statictext", undefined, spineText);

var selVar = aw.add("group");
selVar.orientation = "row";
var rbGroup = selVar.add("group");
//rbGroup.enabled = false;
rbGroup.orientation = "column";
rbGroup.alignChildren = ["left", "center"];
var margins = rbGroup.add("radiobutton", undefined, ms18); // "Поля"
var ratio = rbGroup.add("radiobutton", undefined, ms19); // "Пропорция"
margins.value = true;
var ratiofield = selVar.add("edittext {justify: 'center'}");
ratiofield.text = "? : ? : ? : ?";
ratiofield.characters = 14;
var ratioState = selVar.add("statictext", letterSpace, "\u00A0");
ratiofield.enabled = false;

margins.onClick = function() { // margins.onClick
ratiofield.enabled = false;
topValue.enabled = true;
outValue.enabled = true; 
bottomValue.enabled = true;
} // margins.onClick
///
ratio.onClick = function () { // ratio.onClick
ratiofield.enabled = true;
topValue.enabled = false;
outValue.enabled = false; 
bottomValue.enabled = false;
} // ratio.onClick

var top = aw.add("group");
top.orientation = "row";
top.alignChildren = ["left", "center"];
var topState = top.add("statictext", letterSpace, "–");
var topValue = top.add("edittext {justify: 'center'}");
topValue.text = "?";
topValue.characters = 6; 
var topText = ms20 + bU + getVerticalUnit(country) + aU; // "Верхнее поле,"
var topInfo = top.add("statictext", undefined, topText);
topValue.enabled = false;

var out = aw.add("group");
out.orientation = "row";
out.alignChildren = ["left", "center"];
var outState = out.add("statictext", letterSpace, "–");
var outValue = out.add("edittext {justify: 'center'}");
outValue.text = "?";
outValue.characters = 6; 
var outText = ms21 + bU + getHorizontalUnit(country) + aU; // "Внешнее поле,"
var outInfo = out.add("statictext", undefined, outText);
outValue.enabled = false; 

var bottom = aw.add("group");
bottom.orientation = "row";
bottom.alignChildren = ["left", "center"];
var bottomState = bottom.add("statictext", letterSpace, "–");
var bottomValue = bottom.add("edittext {justify: 'center'}");
bottomValue.text = "?";
bottomValue.characters = 6; 
var bottomText = ms22 + bU + getVerticalUnit(country) + aU; // "Нижнее поле,"
var bottomInfo = bottom.add("statictext", undefined, bottomText);
bottomValue.enabled = false;

separator_a = aw.add ("panel");
separator_a.minimumSize.height = separator_a.maximumSize.height = 1; 

var frameWidth = aw.add("group");
frameWidth.orientation = "row";
frameWidth.alignChildren = ["left", "center"];
var frameWidthState = frameWidth.add("statictext", letterSpace, "\u00A0");
var frameWidthValue = frameWidth.add("edittext {justify: 'center'}");
frameWidthValue.text = "–";
frameWidthValue.characters = 6; 
var frameWidthText = ms23 + bU + getHorizontalUnit(country) + aU; // "Ширина полосы,"
var frameWidthInfo = frameWidth.add("statictext", undefined, frameWidthText);
frameWidthValue.enabled = false;

var frameHeight = aw.add("group");
frameHeight.orientation = "row";
frameHeight.alignChildren = ["left", "center"];
var frameHeightState = frameHeight.add("statictext", letterSpace, "\u00A0");
var frameHeightValue = frameHeight.add("edittext {justify: 'center'}");
frameHeightValue.text = "–";
frameHeightValue.characters = 6; 
var frameHeightText = ms24 + bU + getVerticalUnit(country) + aU; // "Высота полосы,"
var frameHeightInfo = frameHeight.add("statictext", undefined, frameHeightText);
frameHeightValue.enabled = false;

separator_b = aw.add ("panel");
separator_b.minimumSize.height = separator_b.maximumSize.height = 1; 
var buttons = aw.add("group");
var buttonSize = [0,0,108,28];
buttons.alignChildren = ["centrer", "center"];
buttons.orientation = "row";
var o_k = buttons.add("button", buttonSize, "OK");
o_k.enabled = false;
var can_cel = buttons.add("button", buttonSize, "Cancel");
///
can_cel.onClick = function() {  
addDoc.value = false;
aw.close();
}
////
widthValue.onChange = function () { // width.onChange
widthData = getDataValue(widthValue.text, horUnit); 
if (widthData == null) {
    widthState.text = "?";
    frameWidthValue.text = "–";
    o_k.enabled = false;
    return;
    }  
var valid = /^[.\d]+$/.test(widthData) && (!isNaN(widthData)) && !(Number(widthData) <= 0); 
widthValue.text = numberToShow(widthData, horUnit);
if (valid != true) {
    widthState.text = "?";
    o_k.enabled = false;
    return;
    }
else {
    widthState.text = "+";    
    if (testState() == 0) o_k.enabled = true; else o_k.enabled = false;    
    return;
    }
}// width.onChange
////////
heightValue.onChange = function () { // height.onChange
heightData = getDataValue(heightValue.text, verUnit); 
if (heightData == null) {
    heightState.text = "?";
    frameHeightValue.text = "–";
    o_k.enabled = false;
    return;
    }  
var valid = /^[.\d]+$/.test(heightData) && (!isNaN(heightData)) && !(Number(heightData) <= 0); 
heightValue.text = numberToShow(heightData, verUnit);
if (valid != true) {
    heightState.text = "?";
    o_k.enabled = false;
    return;
    }
else {
    heightState.text = "+";    
    if (testState() == 0) o_k.enabled = true; else o_k.enabled = false;    
    return;
    }
}// height.onChange
////////
spineValue.onChange = function () { // spine.onChange
spineData = getDataValue(spineValue.text, horUnit); 
if (spineData == null) {
    spineState.text = "?";
    o_k.enabled = false;
    return;
    }  
var valid = /^[.\d]+$/.test(spineData) && (!isNaN(spineData)) && !(Number(spineData) <= 0); 
spineValue.text = numberToShow(spineData, horUnit);
if (valid != true) {
    spineState.text = "?";
    o_k.enabled = false;
    rbGroup.enabled = false;
    ratiofield.enabled = false;
    topValue.enabled = false;
    outValue.enabled = false; 
    bottomValue.enabled = false;
    return;
    }
else { //=// else
    spineState.text = "+";    
    rbGroup.enabled = true;
    if (margins.value) {
        ratiofield.enabled = false;
        topValue.enabled = true;
        outValue.enabled = true; 
        bottomValue.enabled = true;
        } 
    else {
        ratiofield.enabled = true;
        topValue.enabled = false;
        outValue.enabled = false; 
        bottomValue.enabled = false;
        }    
    if (testState() == 0) o_k.enabled = true; else o_k.enabled = false;    
    return;
    }  //=// else
}// spine.onChange
////////
topValue.onChange = function () { // top.onChange
topData = getDataValue(topValue.text, verUnit); 
if (topData == null) {
    topState.text = "?";
    o_k.enabled = false;
    return;
    }  
var valid = /^[.\d]+$/.test(topData) && (!isNaN(topData)) && !(Number(topData) <= 0); 
topValue.text = numberToShow(topData, verUnit);
if (valid != true) {
    topState.text = "?";
    o_k.enabled = false;
    return;
    }
else {
    topState.text = "+";    
    if (testState() == 0) o_k.enabled = true; else o_k.enabled = false;    
    return;
    }
}// top.onChange
////////
outValue.onChange = function () { // out.onChange
outData = getDataValue(outValue.text, horUnit); 
if (outData == null) {
    outState.text = "?";
    o_k.enabled = false;
    return;
    }  
var valid = /^[.\d]+$/.test(outData) && (!isNaN(outData)) && !(Number(outData) <= 0); 
outValue.text = numberToShow(outData, horUnit);
if (valid != true) {
    outState.text = "?";
    o_k.enabled = false;
    return;
    }
else {
    outState.text = "+";    
    if (testState() == 0) o_k.enabled = true; else o_k.enabled = false;    
    return;
    }
}// out.onChange
////////
bottomValue.onChange = function () { // bottom.onChange
bottomData = getDataValue(bottomValue.text, verUnit); 
if (bottomData == null) {
    bottomState.text = "?";
    o_k.enabled = false;
    return;
    }  
var valid = /^[.\d]+$/.test(bottomData) && (!isNaN(bottomData)) && !(Number(bottomData) <= 0); 
bottomValue.text = numberToShow(bottomData, verUnit);
if (valid != true) {
    bottomState.text = "?";
    o_k.enabled = false;
    return;
    }
else {
    bottomState.text = "+";    
    if (testState() == 0) o_k.enabled = true; else o_k.enabled = false;    
    return;
    }
}// bottom.onChange
////////
ratiofield.onChange = function() { // ratiofield.onChange
var rez = ratiofield.text.split(":");
if (rez.length != 4) { ratioState.text = "?"; o_k.enabled = false; return null; }
if ((isNaN(rez[0]) == true) || (isNaN(rez[1]) == true) || (isNaN(rez[2]) == true) || (isNaN(rez[3]) == true)) { ratioState.text = "?"; o_k.enabled = false; return null; }
if ((rez[0] <= 0) || (rez[1] <= 0) || (rez[2] <= 0) || (rez[3] <= 0)) { ratioState.text = "?"; o_k.enabled = false; return null; }
ratiofield.text = rez[0] + " : " + rez[1] + " : "  + rez[2] + " : " + rez[3];
ratioState.text = " ";
topData = UnitValue(spineData*(rez[1]/rez[0]), horUnit).as(verUnit); // <<
outData = spineData*(rez[2]/rez[0]);
bottomData = UnitValue(spineData*(rez[3]/rez[0]), horUnit).as(verUnit);  // <<
topValue.text = numberToShow(topData, verUnit); 
bottomValue.text = numberToShow(bottomData, verUnit);
outValue.text = numberToShow(outData, horUnit);
topState.text = "+";
outState.text = "+";
bottomState.text = "+";
if (widthState.text == "+" && heightState.text == "+") {
    var frameOK = true;
    var fW = widthData - spineData - outData;
    var fH = heightData - topData - bottomData;
    frameHeightValue.text = numberToShow((fH), verUnit);
    frameWidthValue.text = numberToShow(Number(fW), horUnit);
    if (fW > 0) frameWidthState.text = " "; else { frameWidthState.text = "?"; frameOK = false; }
    if (fH > 0) frameHeightState.text = " "; else { frameHeightState.text = "?"; frameOK = false; }    
    if (frameOK) o_k.enabled = true; else o_k.enabled = false;
    return;
    }
else o_k.enabled = false;
} // ratiofield.onChange
///////
function testState () { // testState
if (widthState.text == "+" && heightState.text == "+" && spineState.text == "+" && topState.text == "+" && outState.text == "+" && bottomState.text == "+") { // == "+"
    var n1 = "1.0";
    var n2 = (UnitValue(topData, verUnit).as(horUnit)/spineData).toFixed(2);  
    var n3 = (outData/spineData).toFixed(2);
    var n4 = (UnitValue(bottomData, verUnit).as(horUnit)/spineData).toFixed(2); 
    ratiofield.text = n1 + " : " + n2 + " : " + n3 + " : " + n4;    
    var frameOK = true;
    var fW = widthData - spineData - outData;
    var fH = heightData - topData - bottomData;
    frameHeightValue.text = numberToShow((fH), verUnit);
    frameWidthValue.text = numberToShow(Number(fW), horUnit);
    if (fW > 0) frameWidthState.text = " "; else { frameWidthState.text = "?"; frameOK = false; }
    if (fH > 0) frameHeightState.text = " "; else { frameHeightState.text = "?"; frameOK = false; }    
    if (frameOK) return 0; else return null;
    } // == "+"
else return null;
} // testState    
/////
o_k.onClick = function() { // o_k.onClick
var nDoc = app.documents.add();
nDoc.viewPreferences.horizontalMeasurementUnits = horUnit;
nDoc.viewPreferences.verticalMeasurementUnits = verUnit;
nDoc.documentPreferences.pageHeight = heightValue.text;
nDoc.documentPreferences.pageWidth = widthValue.text;
nDoc.documentPreferences.facingPages = true;
nDoc.pages.add();
nDoc.pages.add();
var master = nDoc.pages[2].appliedMaster;
var mp0 = master.pages[0]; // это левая страница
var mp1 = master.pages[1]; // это правая страница

mp0.marginPreferences.left = spineValue.text; // это внутреннее поле
mp0.marginPreferences.right = outValue.text; // это внешнее поле
mp0.marginPreferences.top = topValue.text;
mp0.marginPreferences.bottom = bottomValue.text;

mp1.marginPreferences.left = spineValue.text;
mp1.marginPreferences.right = outValue.text;
mp1.marginPreferences.top = topValue.text;
mp1.marginPreferences.bottom = bottomValue.text;

nDoc.marginPreferences.left = spineValue.text;
nDoc.marginPreferences.right = outValue.text;
nDoc.marginPreferences.top = topValue.text;
nDoc.marginPreferences.bottom = bottomValue.text;

spine_cu = spineValue.text;
theRatio = ratiofield.text;

try { app.layoutWindows[0].zoom(2053534835) } catch (e) {}  // FIT_SPREAD 
aw.close();
addDoc.value = false;
save.enabled = true;
//newFileMade = true;
app.activate();
} // o_k.onClick
////
sizesFromFrame.onClick = function () { // sizesFromFrame.onClick 
var gb = ms.geometricBounds;
var wth = doc.documentPreferences.pageWidth;
var hgt = doc.documentPreferences.pageHeight;
var spine = (gb[1] - wth).toFixed(2);
var top = gb[0].toFixed(2);
var fWdth = (gb[3] - gb[1]).toFixed(2);
var fHgt = (gb[2] - gb[0]).toFixed(2);
var out = (wth*2 - gb[3]).toFixed(2);
var bottom = (hgt - gb[2]).toFixed(2);

widthValue.text = numberToShow(wth, horUnit);
widthState.text = "+";

heightValue.text = numberToShow(hgt, verUnit);
heightState.text = "+";

spineValue.text = numberToShow(spine, horUnit);
spineState.text = "+";

topValue.text = numberToShow(top, verUnit);
topState.text = "+";

outValue.text = numberToShow(out, horUnit);
outState.text = "+";

bottomValue.text = numberToShow(bottom, verUnit);
bottomState.text = "+";

frameWidthValue.text = numberToShow(fWdth, horUnit);
frameWidthState.text = "+";

frameHeightValue.text = numberToShow(fHgt, verUnit);
frameHeightState.text = "+";

var n2 = (top/spine).toFixed(2);
var n3 = (out/spine).toFixed(2);
var n4 = (bottom/spine).toFixed(2);
ratiofield.text = "1.0" + " : " + n2 + " : " + n3 + " : " + n4;
ratioState.text = "+";

spineData = spine;
topData = top;
outData = out;
bottomData = bottom;
widthData = wth;
heightData = hgt;

rbGroup.enabled = true;
ratiofield.enabled = true;
ratiofield.enabled = true;
topValue.enabled = true;
outValue.enabled = true; 
bottomValue.enabled = true;

o_k.enabled = true;
} // sizesFromFrame.onClick 
///
aw.show();
} // makeNewDoc
//////////////
function numberToShow(value, unit) { // numberToShow
//var theValue =     
var u = String(unit);
if (u != "PICAS" && u != "CICEROS") return value;
var rez = "";
var numberPT = UnitValue(Number(value), unit).as("pt");
if (u == "PICAS") { // PICAS
    var floatRez = parseFloat(numberPT/12);
    if (isNaN(floatRez)) return null;
    var entier = parseInt(numberPT/12);
    if (isNaN(entier)) return null;    
    var diff = floatRez - entier;  
    if (entier == 0 && diff == 0) return null;
    var fraction = (diff*12).toFixed(3); // .toFixed(2)
    rez = entier + "p" + fraction;
    }  // PICAS
else { // CICEROS
    var numberPTc = Number(numberPT)/(UnitValue("1ci").as("pt"));    
    var floatRez = parseFloat(numberPTc);
    if (isNaN(floatRez)) return null;    
    var entier = parseInt(numberPTc);
    if (isNaN(entier)) return null;      
    var diff = floatRez - entier; 
    if (entier == 0 && diff == 0) return null;  
    var fraction = (diff*12).toFixed(3); // .toFixed(2)
    rez = entier + "c" + fraction;    
    } // CICEROS 
return rez;
} // numberToShow
//////////
function myGetScriptPath() { // myGetScriptPath
try {
    return app.activeScript;
}
catch (myError) {
    return File(myError.fileName);
}
} // myGetScriptPath()
////////


