﻿// PointSizeLine.jsx

/*

Линия размеров: наращение по золотому сечению, это множитель (1,618)  или по другому множителю.
Текущий кегль будет стартовым значением.
Линейка размеров будет отображена в окне.
Первая строка при запуске: выбранная гарнитура и текущий кегль как стартовое значение.
После этой строки будет текст с изменениями размеров.

*/    
/*
var country = "ru";    
var mn01 = "Последовательность размеров";
var mn02 = "Нет открытого файла.";
var mn03 = "Курсор должен быть в текстовом фрейме.";
var mn04 = "Варианты наращения величины кегля";
var mn05 = "золотое сечение";
var mn06 = "пропорция Фибоначчи";
var mn07 = "ваш множитель";
var mn08 = "Текст для вывода разными размерами";
var mn09 = "В поле ввода множителя должно быть положительное число больше единицы.";
var mn10 = "В этой программе предполагается, что размер шрифта не будет меньше 3 пунктов.";
var mn11 = "Это поле только для отображения линейки последовательных размеров. Оно не должно редактироваться.";
var mn12 = "Книга";
var mn13 = "Текст разного размера";
var mn14 = "#4Rus.PDF";
var mes15 = "Не найден PDF-файл с описанием этой программы. Он называется '";
var mes16 = "' и должен быть в папке 'Info' этого скрипта.";
*/


var country = "us";
var mn01 = "Size sequence";
var mn02 = "No open file";
var mn03 = "The cursor should be in a text frame";
var mn04 = "Options for increasing of the pointsize";
var mn05 = "gold ratio";
var mn06 = "Fibonacci proportion";
var mn07 = "your multiplier";
var mn08 = "Text to output in different sizes";
var mn09 = "There must be a positive number greater than one in the multiplier input field";
var mn10 = "In this program, it is assumed that the pointsize will not be less than 3 points";
var mn11 = "This field is only for displaying consecutive sizes. It should not be edited";
var mn12 = "Book";
var mn13 = "Text of different sizes";
var mn14 = "#4Eng.PDF";
var mes15 = "The PDF file with the description of this program not found. It's named '";
var mes16 = "' and should be in the 'Info' folder of this script";

//////////////////////////////////////

var showFibonacciOption = false; // когда true в окне будет оция выбора пропорции Фибоначчи. Результат такой же, как при варианте "золотое сечение", поэтому эту опцию можно отключить

#targetengine "PointSizeLine"

var programTitul = mn01; // "Последовательность размеров"

if (app.documents.length == 0) {
    alert(mn02,programTitul); // "Нет открытого файла."
    exit();
    }
var sel = app.selection[0];
if (sel == null || sel.constructor.name != "InsertionPoint") {
    alert(mn03, programTitul); // "Курсор должен быть в текстовом фрейме."
    exit();
    }
var rez = [];
////
var w = new Window( 'palette', programTitul, undefined, {closeButton: true});
w.alignChildren = ["fill", "fill"];
w.add("statictext", undefined, mn04); // "Варианты наращения величины кегля"
var variants = w.add("group");
variants.orientation = "row";
var goldRatio = variants.add("radiobutton", undefined, mn05); // "золотое сечение"
if (showFibonacciOption) var fibonacci = variants.add("radiobutton", undefined, mn06); // "пропорция Фибоначчи"
var yourMultiplier = variants.add("radiobutton", undefined, mn07); // "ваш множитель"
var yourNumber = variants.add ("edittext {justify: 'center'}", undefined);
yourNumber.enabled = false;
yourNumber.characters = 5;
yourNumber.text = "1.41";
var rezLine = w.add ("edittext {justify: 'center'}", undefined);
separator_a = w.add ("panel");
separator_a.minimumSize.height = separator_a.maximumSize.height = 1; 
w.add("statictext", undefined, mn08); // "Текст для вывода разными размерами"
var texForShow = w.add ("edittext {justify: 'center'}", undefined);
texForShow.text = mn12; // Книга
texForShow.enabled = false;
separator_b = w.add ("panel");
separator_b.minimumSize.height = separator_b.maximumSize.height = 1; 
var buttons = w.add("group");
var lengthOK;
if (country == "ru") lengthOK = 270; else lengthOK = 220;
if (showFibonacciOption) {
    if (country == "ru") lengthOK = 430; else lengthOK = 370;
    }
var action = buttons.add("button", [0, 0, lengthOK, 28], mn13);
var info =  buttons.add("button", [0,0,28,28], "?");
action.enabled = false;
///
info.onClick = function() { // info.onClick
var pdfName = mn14;
app.pdfExportPreferences.properties.viewPDF = true;   
var myScriptFile = myGetScriptPath();
var myScriptFolder = decodeURI(myScriptFile.path);  
var infoFile = File(decodeURI(myScriptFolder + "/Info/" + pdfName)); 
if (!infoFile.exists) { 
    alert(mes15 + pdfName + mes16, programTitul); // "Не найден PDF-файл с описанием этой программы. Он называется '"  "' и должен быть в папке 'Info' этого скрипта."
    return; 
    }
else {
        infoFile.execute();
    }
} // info.onClick
//////
function myGetScriptPath() { // myGetScriptPath
try {
    return app.activeScript;
    }
catch (myError) {
    return File(myError.fileName);
    }
} // myGetScriptPath()
////
goldRatio.onClick = function () { // goldRatio.onClick 
var ps;   
var tmp;
while (rez.length > 0)rez.pop();
yourMultiplier.value = false;
if (showFibonacciOption) fibonacci.value = false;
yourNumber.enabled = false;
ps = getSize();
if (ps == null) return;
rez.push(ps);
tmp = ps;
for (i = 1; i < 6; i++) { // i++
    tmp = tmp*1.618;
    rez.push((tmp).toFixed(0));
    } // i++
tmp = rez.join(", ");
rezLine.text = tmp;
joinedValues = tmp;
action.enabled = true;
texForShow.enabled = true;
} // goldRatio.onClick
///
if (showFibonacciOption) {
fibonacci.onClick = function () { // fibonacci.onClick
var ps;   
var tmp;
var tmp2;
var prev;
while (rez.length > 0)rez.pop();    
yourMultiplier.value = false;
goldRatio.value = false;
yourNumber.enabled = false;
ps = getSize();
if (ps == null) return;
prev = ps/1.618;
tmp = ps;
rez.push(ps);
for (i = 1; i < 6; i++) { // i++
    tmp2 = Number(tmp) + Number(prev);
    rez.push((tmp2).toFixed(0));    
    prev = tmp;
    tmp = tmp2;
    } // i++
tmp = rez.join(", ");
rezLine.text = tmp;
joinedValues = tmp;
action.enabled = true;
texForShow.enabled = true;
} // fibonacci.onClick
}
///
yourMultiplier.onClick = function () { // yourMultiplier.onClick
goldRatio.value = false;
if (showFibonacciOption) fibonacci.value = false;    
yourMultiplier.value = true;
yourNumber.enabled = true; 
setMult();
} // yourMultiplier.onClick
///
function setMult() { // setMult()
var k = 1.41;  
n = 8;
var ps;   
var tmp;
while (rez.length > 0)rez.pop();
ps = getSize();
if (ps == null) return;
///
regExp = new RegExp(/,/g); // ищем все запятые в строке
yourNumber.text = yourNumber.text.replace(regExp, "\.");  
var valid = /^[.\d]+$/.test(yourNumber.text) && (!isNaN(yourNumber.text)) && !(Number(yourNumber.text) <= 1); 
if (!valid) { // !valid
    alert(mn09, programTitul); // "В поле ввода множителя должно быть положительное число больше единицы."
    rezLine.text = "";
    action.enabled = false;
    texForShow.enabled = false;    
    return;
    } // !valid
k = Number(yourNumber.text);
if (k <1.5) n = 7;
if (k < 1.4) n =9;
if (k <1.3) n = 11;
rez.push(ps);
tmp = ps;
for (i = 1; i < n; i++) { // i++
    tmp = tmp*k;
    rez.push((tmp).toFixed(0));
    } // i++
tmp = rez.join(", ");
rezLine.text = tmp;
joinedValues = tmp;
action.enabled = true;
texForShow.enabled = true;
} // setMult()
///
yourNumber.onChange = function () { setMult(); }
///
function getSize() { // getSize
if (app.documents.length == 0) {
    alert(mn02,programTitul); // "Нет открытого файла."
    rezLine.text = "";
    action.enabled = false;
    texForShow.enabled = false;     
    return null;
    }    
sel = app.selection[0];
if (sel == null || sel.constructor.name != "InsertionPoint") { // == null
    alert(mn03, programTitul); // "Курсор должен быть в текстовом фрейме."
    rezLine.text = "";
    action.enabled = false;
    texForShow.enabled = false;    
    return null;
    } // == null
var tF = sel.parentTextFrames[0];
var ps = tF.texts[0].insertionPoints[0].pointSize;
tF.texts[0].insertionPoints[0].select();
sel = app.selection[0];
if (ps < 3) { // < 3
    alert(mn10, programTitul); // "В этой программе предполагается, что размер шрифта не будет меньше 3 пунктов."
    rezLine.text = "";
    action.enabled = false;
    texForShow.enabled = false;    
    return null;    
    } // < 3
return ps;
} // getSize
///
rezLine.onChanging = function () { // rezLine.onChanging
if (app.documents.length == 0) { rezLine.text = ""; action.enabled = false; texForShow.enabled = false; return; }    
alert(mn11, programTitul); // "Это поле только для отображения линейки последовательных размеров. Оно не должно редактироваться."
rezLine.text = joinedValues;
app.activate(); // чтобы убрать курсор из строки с размерами
} // rezLine.onChanging    
///
action.onClick = function () { // action.onClick 
var ps;
var line = "";
ps = getSize();
if (ps == null) return;
var tF = sel.parentTextFrames[0];
tF.texts[0].contents = "";
for (var i = 0; i < rez.length; i++) { // i++
    line = String(rez[i]) + " : " + String(texForShow.text) + "\r";
    tF.texts[0].insertionPoints[-1].contents = line;
    tF.texts[0].paragraphs[-1].pointSize = Number(rez[i]);
    } // i++
tF.texts[0].insertionPoints[0].select();
app.activate();
} // action.onClick 
///
w.show();


